
# This is a fix for InnoDB in MySQL >= 4.1.x
# It "suspends judgement" for fkey relationships until are tables are set.
SET FOREIGN_KEY_CHECKS = 0;

#-----------------------------------------------------------------------------
#-- blog_post
#-----------------------------------------------------------------------------

DROP TABLE IF EXISTS `blog_post`;


CREATE TABLE `blog_post`
(
	`id` INTEGER  NOT NULL AUTO_INCREMENT,
	`created_at` DATETIME,
	PRIMARY KEY (`id`)
)Type=InnoDB;

#-----------------------------------------------------------------------------
#-- blog_post_i18n
#-----------------------------------------------------------------------------

DROP TABLE IF EXISTS `blog_post_i18n`;


CREATE TABLE `blog_post_i18n`
(
	`title` VARCHAR(255)  NOT NULL,
	`announce` TEXT,
	`body` TEXT,
	`id` INTEGER  NOT NULL,
	`culture` VARCHAR(7)  NOT NULL,
	PRIMARY KEY (`id`,`culture`),
	CONSTRAINT `blog_post_i18n_FK_1`
		FOREIGN KEY (`id`)
		REFERENCES `blog_post` (`id`)
		ON DELETE CASCADE
)Type=InnoDB;

#-----------------------------------------------------------------------------
#-- blog_comment
#-----------------------------------------------------------------------------

DROP TABLE IF EXISTS `blog_comment`;


CREATE TABLE `blog_comment`
(
	`id` INTEGER  NOT NULL AUTO_INCREMENT,
	`blog_post_id` INTEGER,
	`author` VARCHAR(255),
	`email` VARCHAR(255),
	`body` TEXT,
	`created_at` DATETIME,
	PRIMARY KEY (`id`),
	INDEX `blog_comment_FI_1` (`blog_post_id`),
	CONSTRAINT `blog_comment_FK_1`
		FOREIGN KEY (`blog_post_id`)
		REFERENCES `blog_post` (`id`)
)Type=InnoDB;

# This restores the fkey checks, after having unset them earlier
SET FOREIGN_KEY_CHECKS = 1;
