<?php

class BlogPost extends BaseBlogPost
{
  /**
   * For support i18n of admin generator
    *
   * @param string $method
   * @param mixed $arguments
   * @return mixed
   */
  public function __call($method, $arguments)
  {
    $data = split('I18n', $method, 2);

    if( count($data) != 2 )
    {
      // call original call for support sfPropelBehavior
      return parent::__call($method, $arguments);
    }

    list( $method, $culture ) = $data;

    if (4 == strlen($culture))
    {
      $culture = strtolower(substr($culture, 0, 2)) . '_' . strtoupper(substr($culture, 2, 2));
    }
    else
    {
      $culture = strtolower($culture);
    }

    $this->setCulture( $culture );

    return call_user_func_array(array($this, $method), $arguments);
  }

}
